<script>
	import "swiper/scss"
	import "swiper/css/navigation"
	import "swiper/css/lazy"
	import "swiper/css/effect-fade"
  import "swiper/css/thumbs"

	import srcset from "@/helpers/srcset"

	import { FreeMode, Navigation, Thumbs, Lazy, EffectFade } from "swiper"
	import { Swiper, SwiperSlide } from "swiper/svelte"
	import { tick } from "svelte"

	export let images = []
	
	let thumbs = null

	const setThumbs = async e => {
		const [swiper] = e.detail
		
		await tick()
		thumbs = swiper
	}

	$: images = images.sort((a,b) => a.position > b.position ? 1 : -1)
</script>

<template lang="pug">
+if('images && images.length')
	.car-carousel.is-clipped
		Swiper(
			spaceBetween='{10}'
			effect!='{"fade"}'
			lazy='{true}'
			thumbs='{{ swiper: thumbs }}'
			modules='{[FreeMode, Thumbs, Lazy, EffectFade]}')
			+each('images as image')
				SwiperSlide
					.img
						img.bg( data-src!='{srcset(image.filename)["x85"]}' )
						img.swiper-lazy( data-src!='{srcset(image.filename)["1440xw"]}' )
					.swiper-lazy-preloader.swiper-lazy-preloader-white
		Swiper.thumbs(
			on:swiper='{setThumbs}'
			spaceBetween='{8}'
			slidesPerView='{4}'
			lazy='{true}'
			freeMode='{true}'
			navigation='{true}'
			watchSlidesProgress='{true}'
			modules='{[FreeMode, Navigation, Thumbs, Lazy]}')
			+each('images as image')
				SwiperSlide
					.img
						img.swiper-lazy.bg( data-src!='{srcset(image.filename)["400x"]}' )
						img.swiper-lazy.main( data-src!='{srcset(image.filename)["x85"]}' )
					.swiper-lazy-preloader.swiper-lazy-preloader-white
</template>

<style lang="scss">
	.car-carousel {
		.bg {
			width: auto;
			min-width: 200%;
			height: auto;
			margin: auto;
			filter: blur(15px);
			top: -50%;
			right: -50%;
			bottom: -50%;
			left: -50%;
		}
		:global(.thumbs) {
			margin-top: .5rem;
		}
		:global(.thumbs .swiper-slide) {
			cursor: pointer;
			filter: brightness(.5);
			transition: all .2s ease-in-out;
		}

		:global(.thumbs .swiper-slide.swiper-slide-thumb-active) {
			filter: brightness(1);
		}

		:global(.swiper-button-prev),
		:global(.swiper-button-next) {
			width: 2rem;
			height: 2rem;
			border-radius: 50%;
			background: $primary;
		}

		:global(.swiper-button-prev::after),
		:global(.swiper-button-next::after) {
			font-size: 1rem;
			font-weight: 900;
			color: $dark;
		}

		:global(.swiper-button-prev::after) {
			margin-left: -2px;
		}

		:global(.swiper-button-next::after) {
			margin-right: -2px;
		}
	}

	.img {
		padding-top: 56.25%;
		position: relative;
		overflow: hidden;
		img {
			width: 100%;
			margin: auto;
			position: absolute;
			top: -50%;
			right: -50%;
			bottom: -50%;
			left: -50%;
		}
	}
</style>